import { Controller } from "@/comm/core/controller";
import { RxValue } from "../rxValue";
import { PackSource } from "@/comm/objects/packSource";
import { useCtx } from "@/comm/ctx";
import { PackScene } from "@/comm/objects/pack";


export class EditorCtrl extends Controller {
    state = RxValue.create({
        currSceneIndex: -1,
    })
    pack: PackSource
    constructor(pack: PackSource) {
        super();
        this.pack = pack;
        if (pack.scenes.length > 0) {
            this.state.currSceneIndex = 0;
        }
    }
    addEmptyPackScene() {
        let s = new PackScene();
        let scenes = this.pack.state.scenes.slice(0);
        scenes.push(s);
        this.pack.state.setScenes(scenes);
    }

    removePackScene(index:number) {
        console.log("remove scene=>", index);
    }
    loadScene(index:number) {
        const scene = this.pack.scenes[index]
        const ctx = useCtx();

        this.state.currSceneIndex = index;
        // ctx.gpuCtrl.proxy.loadScene(scene as any, this.pack as any);
    }

    get currScene() {
        return this.pack.scenes[this.state.currSceneIndex];
    }
    get products() {
        return this.pack.state.products
    }

    get currActiveMat() {
        return null;
    }

    updateCurrPackFormData(data:any, path:string, value:string) {
        console.log("data=>", data, path, value);
    }

    updateMatByColorMatch(data:any, mat:any) {
        console.log("updateMatByColorMatch=>", data, mat);
    }

    updateEditItemBaseInfo(data:any, result:any) {
        console.log("updateEditItemBaseInfo=>", data, result);
    }

    updateEditItemThumbnail(data:any, type: string ) {//"screenshot" | "upload" 
        console.log("updateEditItemThumbnail=>", data, type);
    }
}