import * as Controls from "../controllers";

const ctx: { [key: string]: any } = {
  prjCtrl: new Controls.ProjectController(),
  deviceCtrl: new Controls.DeviceController(),
};

const initOrder = ["deviceCtrl", "prjCtrl"];

export async function InitControllers() {
  console.log("begin init ");
  let n = initOrder.length;
  for (let i = 0; i < n; i++) {
    await ctx[initOrder[i]].onReady();
  }
  const keys = Object.keys(ctx);
  n = keys.length;
  while (n--) {
    if (initOrder.indexOf(keys[n]) != -1) {
      keys.splice(n, 1);
    }
  }
  keys.forEach((k) => {
    ctx[k].onReady();
  });
  console.log("end init");
}

export function useCtx() {
  return ctx;
}
