import { nanoid } from "nanoid";
import { createBackground, createOss } from "./create";
import { RxValue } from "@/comm/controllers/rxValue";

export class PackEnv {
  id = nanoid();
  name = "";
  cusNum = "";
  thumbnail = createOss();
  hdr = createOss();
  file = createOss();
  config: any = null;
  userData: any;

  state = RxValue.create({
    background: createBackground(),
    options: {
      rotation: 0,
      exposure: 1,
    },
    toneMap: {
      method: 1, //0 "linear" 值0 "reinhard" 值 1 "filmic”:值2
      exposure: 1.0,
      brightness: 0.1,
      contrast: 0.06,
      saturation: 1,
    }
  })
  get options() {
    return this.state.options;
  }
  
  toJson() {
    return {
      id: this.id,
      name: this.name,
      cusNum: this.cusNum,
      thumbnail: this.thumbnail,
      hdr: this.hdr,
      file: this.file,
      config: this.config,
      userData: this.userData,
      ...this.state.toJson(),
    }
  }

  fromJson( data:any ) {
    this.id = data.id;
    this.name = data.name;
    this.cusNum = data.cusNum;
    this.thumbnail = data.thumbnail;
    this.hdr = data.hdr;
    this.file = data.file;
    this.config = data.config;
    this.userData = data.userData;
    this.state.fromJson(data);
  }
}
