import { nanoid } from "nanoid";
import { createOss } from "./create";
import { PackProductComp } from "./PackProductComp";


export class PackProduct {
  id = nanoid();
  userData: any;
  geomId = "";
  name = "";
  cusNum = "";
  type = ""; //shoe  heel sole xx
  thumbnail = createOss();
  components = [] as PackProductComp[]
  
  toJson() {
    
    return {
      id : this.id,
      userData: this.userData,
      geomId: this.geomId,
      name: this.name,
      cusNum: this.cusNum,
      type: this.type,
      thumbnail: this.thumbnail,
      components: this.components.map(c=>c.toJson()),
    }
  }

  fromJson(data:any) {
     this.id = data.id;
     this.userData = data.userData;
     this.geomId = data.geomId;
     this.name = data.name;
     this.cusNum = data.cusNum;
     this.type = data.type;
     this.thumbnail = data.thumbnail;

     const comps = (data.components||[]).filter((item: any)=>!!item)
     this.components = (comps || []).map((d:any)=>{
        const c = new PackProductComp();
        c.fromJson(d);
        return c;
     })
  }
}


