import { nanoid } from "nanoid";
import { PackSource } from "./extends";
import { RxValue } from "@/comm/controllers/rxValue";

export class PackSceneProduct {
  id = nanoid();
  state = RxValue.create({
    prodId: "",
    transform: {
      pos: [0, 0, 0],
      scale: [1, 1, 1],
      rotation: [0, 0, 0, 1],
    },
    visible: true,
    noShadow: false, //不显示阴影
  })
  toJson() {
    return {id: this.id, ...this.state.toJson()}
  }
  fromJson(data:any) {
    this.id = data.id;
    this.state.fromJson( data );
  }
}
