import { nanoid } from "nanoid";

export function createUid(type = "PackSource") {
  return `${type}_${nanoid()}`;
}
export type OssType = {
  url: string;
  size:number;
}

export function createOss(): OssType {
  return { url: "", size: 0 };
}

export function createDiamond() {
  return {
    brightness: 1.0,
    color: [0.4, 0.4, 0.4],
    scaleX: 1,
    scaleY: 1,
  };
}

export function createUV() {
  return { scale: 1, rotate: 0, offsetX: 0.5, offsetY: 0 };
}

export function createBackground() {
  return {
    type: 1,
    color: [1, 1, 1],
    image: createOss(),
  };
}

type MatFeature = {
  factor: number;
  color: number[];
  texture: {
    url: string;
    size: number;
  };
  useTexture: boolean;
  enable: boolean;
};

export function createTexture<
  T extends Partial<MatFeature>,
  R extends T & { texture: OssType; useTexture: boolean }
>(options: T): { [name in keyof R]: R[name] } {
  return Object.assign(
    { texture: createOss(), useTexture: false },
    options
  ) as any;
}
