import { PackEnv } from "./PackEnv";
import { PackGeom } from "./PackGeom";
import { PackMat } from "./PackMat";
import { PackProduct } from "./PackProduct";
import { PackScene } from "./PackScene";
import { PackSource } from "../packSource";

export class Pack {
    
    
    source = new PackSource();

    // 添加模型
    addGeom(geom: PackGeom) {
        this.source.geoms.push(geom);
        return geom;
    }
  
    // 添加材质
    addMat(mat: PackMat) {
       this.source.mats.push(mat);
       return mat;
    }
  
    // 添加环境
    addEnv(env: PackEnv) {
       this.source.env3ds.push(env);
       return env;
    }
  
    // 添加单品
    addProduct(product: PackProduct, source: PackSource = this.source) {

      const geom = source.geoms.find((item) => item.id === product.geomId);
      geom && (product.geomId = this.addGeom(geom).id);

      product.components.forEach((comp) => {
        const mat = source.mats.find((mat) => mat.id === comp.matId);
        mat && (comp.state.matId = this.addMat(mat).id);
      });
       this.source.products.push(product);
       return product;
    }
  
    // 添加场景
    addScene(scene: PackScene) {
      this.source.scenes.push(scene);
      return scene;
    }
  }
  