import { Dict_Imgs } from "@/dict";
import { createAttrsForm } from "../../defines/createAttrsForm";
import { InputNumber, Switch } from "ant-design-vue";
import { createColorOpts } from "../../defines/formOpts/createColorOpts";
import Slider from "../../formItems/Slider";
import { DesignCompObj } from "@/modules/editor/objects/DesignTemp/DesignComp";
import { RxValue } from "@/modules/editor/controllers/ReactCtrl/rxValue";

export { Component } from "./component";

export const options = {
  name: "直线",
  thumbnail: require("@/modules/editor/assets/icons/line.svg"),
};
const LineValue = {
  lineColor: "#000000",
  lineWidth: 1,
  dashX: 0,
  dashY: 0,
}
export function createComp() {
  return new CompLineObj();
}

export class CompLineObj extends DesignCompObj<typeof LineValue> {
  value = RxValue.create({...LineValue});
  onCreated() {
    this.compKey = "Line";
    this.layout.size = [400, 30];
  }
}


export const Form = createAttrsForm([
  {
    label: "线宽",
    dataIndex: "value.lineWidth",
    component: InputNumber,
  },
  {
    label:"颜色",
    dataIndex: "value.lineColor",
    ...createColorOpts(),
  },
  {
    label: "实线长",
    dataIndex: "value.dashX",
    component: Slider,
    props: {
        defaultValue: 0,
        min: 0,
        max: 750,
        step: 1,
    },
},
{
    label: "空白长",
    dataIndex: "value.dashY",
    component: Slider,
    props: {
        defaultValue: 0,
        min: 0,
        max: 750,
        step: 1,
    },
},
]);
