import { DesignCompObj } from "@/modules/editor/objects/DesignTemp/DesignComp";
import { createAttrsForm } from "../../defines/createAttrsForm";
import MapAttr from "../../formItems/MapAttr";
import { RxValue } from "@/modules/editor/controllers/ReactCtrl/rxValue";

export { Component } from "./component";

export const options = {
  name: "地图",
  thumbnail: require("@/modules/editor/assets/icons/address.svg"),
};

const MapValue = {
  addressInfo: {
    lnglat: [116.397428, 39.90923],
    address: "天安门",
  },
}

export class CompMapObj extends DesignCompObj<typeof MapValue> {
  value = RxValue.create({...MapValue})

  onCreated() {
    this.compKey = "Map";
    this.layout.size = [710, 710];
  }
}

export function createComp() {
  return new CompMapObj();
}

export const Form = createAttrsForm([
  {
    dataIndex: "value.addressInfo",
    component: MapAttr,
  },
]);
