import { Design_Page_Size } from "@/modules/editor/dicts/CompOptions";
import { PageForm } from "./PageForm";
import { DesignCompObj } from "@/modules/editor/objects/DesignTemp/DesignComp";
import { RxValue } from "@/modules/editor/controllers/ReactCtrl/rxValue";

export { Component } from "./component";

export const options = {
  name: "页面",
  thumbnail: require("@/modules/editor/assets/icons/container.svg"),
};

const PageValue = {
  useFor: "mobile",
  pageMode: "long",
  pageSizeType: "normal",
  music:  ""
}

export class CompPageObj extends DesignCompObj<typeof PageValue> {
  value = RxValue.create({...PageValue})
  onCreated() {
    this.compKey = "Page";
    this.layout.size = [...(Design_Page_Size as [number, number])]
    this.layout.background.color = "#ffffff";
  }
}
export function createComp() {
  return new CompPageObj();
}

export const Form = PageForm;
