import "@ckeditor/ckeditor5-build-classic/build/translations/zh-cn";
import { createAttrsForm } from "../../defines/createAttrsForm";
import { TextToolForm } from "./TextToolForm";
import { DesignCompObj } from "@/modules/editor/objects/DesignTemp/DesignComp";
import { RxValue } from "@/modules/editor/controllers/ReactCtrl/rxValue";
export { Component } from "./component2";

export const options = {
  name: "文本",
  thumbnail: require("@/modules/editor/assets/icons/text2.svg"),
};


const TextValue = {
  text: `<p style="text-align:center;line-height:1.5;"><span style="font-size:18px;">请输入内容</span></p>`
}

export class CompTextObj extends DesignCompObj<typeof TextValue> {
  value = RxValue.create({...TextValue})
  onCreated() {
    this.compKey = "Text";
    this.layout.size = [750, 60];
  }
  fromJson(data:any) {
    if (data.value.text == undefined && typeof data.value == "string" ) {
      data.value = {text: data.value};
    }
    super.fromJson(data);
  }
}

export function createComp() {
  return new CompTextObj();
}

export const Form = createAttrsForm(
  [
    // {
    //   label: "文本",
    //   dataIndex: "value",
    //   component: "Input",
    // },
  ],
  TextToolForm
);
