import { createAttrsForm } from "../../defines/createAttrsForm";
import { InputNumber, Switch } from "ant-design-vue";
import { createColorOpts } from "../../defines/formOpts/createColorOpts";
import { DesignCompObj } from "@/modules/editor/objects/DesignTemp/DesignComp";
import { RxValue } from "@/modules/editor/controllers/ReactCtrl/rxValue";

export { Component } from "./component";

export const options = {
  name: "三角形",
  thumbnail: require("@/modules/editor/assets/icons/triangle.svg"),
};

const TriangleValue = {
  lineColor: "#000000",
    lineWidth: 0,
    isFill: true,
    fillColor: "#A4A4A4",
    reverseFill: false,
}

export class CompTriangleObj extends DesignCompObj<typeof TriangleValue> {
  value = RxValue.create({...TriangleValue})
  onCreated() {
    this.compKey = "Triangle";
    this.layout.size = [400, 400];
  }
}
export function createComp() {
  return new CompTriangleObj();
}


export const Form = createAttrsForm([
  {
    label: "线宽",
    dataIndex: "value.lineWidth",
    component: InputNumber,
  },
  {
    label:"颜色",
    dataIndex: "value.lineColor",
    ...createColorOpts(),
  },
  {
    label: "是否填充",
    dataIndex: "value.isFill",
    component: "Switch",
  },
  {
    label:"填充颜色",
    dataIndex: "value.fillColor",
    ...createColorOpts(),
    isVisible: (value, data) => data?.value?.isFill == true,
  },
  {
    label:"反向填充",
    dataIndex: "value.reverseFill",
    component: "Switch",
    isVisible: (value, data) => data?.value?.isFill == true,
  },
]);
