import { DesignCompObj } from "@/modules/editor/objects/DesignTemp/DesignComp";
import { createAttrsForm } from "../../defines/createAttrsForm";
import { ImagePicker } from "../../formItems/ImagePicker";
import { RxValue } from "@/modules/editor/controllers/ReactCtrl/rxValue";

export { Component } from "./component";

export const options = {
  name: "视频",
  thumbnail: require("@/modules/editor/assets/icons/video2.svg"),
};


const VideoValue = {
  url: "//sku3d-test.obs.cn-east-3.myhuaweicloud.com/queenshow/1689723277730_hPbfyN_shoe.mp4",
  ratio: 0,
  autoplay: true,
  loop: true,
  controls: true,
  poster: "",
}

export class CompVideoObj extends DesignCompObj<typeof VideoValue> {
  value = RxValue.create({...VideoValue})
  onCreated() {
    this.compKey = "Video";
    this.layout.size = [750, 750];
  }
}

export function createComp() {
  return new CompVideoObj();
}

export const Form = createAttrsForm([
  // {
  //   label: "视频地址",
  //   dataIndex: "value.url",
  //   component: "Input",
  // },
  {
    label: "封面",
    dataIndex: "value.poster",
    component: ImagePicker,
  },
  {
    label: "视频比例",
    dataIndex: "value.ratio",
    component: "Select",
    props: {
      options: [
        { label: "原始比例", value: 0 },
        { label: "1:1", value: 1 },
        { label: "4:3", value: 4 / 3 },
        { label: "3:4", value: 3 / 4 },
        { label: "16:9", value: 16 / 9 },
        { label: "9:16", value: 9 / 16 },
      ],
    },
  },
  // {
  //   label: "自动播放",
  //   dataIndex: "value.autoplay",
  //   component: "Switch",
  // },
  {
    label: "循环播放",
    dataIndex: "value.loop",
    component: "Switch",
  },
  // {
  //   label: "显示控制器",
  //   dataIndex: "value.controls",
  //   component: "Switch",
  // },
]);
