import { useEditor } from "@/modules/editor";
import { defineUI } from "queenjs";
import History from "../Toolbar/History";
import SaveOrShare from "./SaveOrShare";

export default defineUI({
  setup() {
    const editor = useEditor();
    const { controls, jumpIndexHtml } = editor;

    return () => (
      <div class="relative flex justify-between items-center">
        <div class="flex items-center">
          <aside>
            <img
              class="h-40px cursor-pointer"
              src={require("@/assets/imgs/Logo.png")}
              alt="logo"
              onClick={() => jumpIndexHtml()}
            />
          </aside>
          <History class="ml-100px" />
        </div>
        {/* <Radio.Group
          value={store.mode}
          onChange={(e) => actions.switchMode(e.target.value)}
        >
          <Radio.Button value={store.isEditPage ? "editPage" : "editComp"}>
            编辑
          </Radio.Button>
          <Radio.Button value="preview">预览</Radio.Button>
        </Radio.Group> */}
        <div class="absolute left-1/2 top-1/2 transform -translate-x-1/2 -translate-y-1/2">
          <div class="text-16px font-bold text-light-50 max-w-240px truncate leading-normal">
            {controls.pageCtrl.state.title}
          </div>
        </div>
        <SaveOrShare />
      </div>
    );
  },
});
