import { Empty } from "@queenjs/ui";
import { defineUI } from "queenjs";
import { useEditor } from "../../../..";
import { css } from "@linaria/core";

export default defineUI({
  setup() {
    const editor = useEditor();
    const props = editor.controls.propsCtrl;

    return () => {
      const currComp = props.getCurrComp();
      const Form =
        editor.controls.compUICtrl.state.components.get(currComp?.compKey)
          ?.Form || Empty;
      return (
        <div class="flex flex-col h-1/1">
          <div class="p-16px px-8px border-bottom !border-2px">设置栏</div>
          <div class="flex-1 p-16px px-8px scrollbar">
            <Form component={currComp} />
          </div>
        </div>
      );
    };
  },
});

const compTreeCls = css`
  .ant-tree-node-content-wrapper.ant-tree-node-selected {
    background-color: #404040;
  }
`;
