import { css } from "@linaria/core";
import { defineUI } from "queenjs";
import { TipIcons } from "../../TipIcons";
import { history } from "@/modules/editor/objects/DesignTemp/factory";

export default defineUI({
  setup() {
    const h = history;
    return () => {
      const undoDisable = !h.refCanUndo.value || !h.enable;
      const redoDisable = !h.refCanRedo.value || !h.enable;

      return (
        <div class="space-x-20px z-999">
          <TipIcons.Undo
            disable={ undoDisable }
            class={btnCls}
            onClick={() => h.undo()}
          />
          <TipIcons.Redo
            disable={ redoDisable }
            class={btnCls}
            onClick={() => h.redo()}
          />
        </div>
      );
    };
  },
});

const btnCls = css`
  color: #fff;
  font-size: 22px;
  &.icon_disable {
    color: #fff;
    opacity: 0.5;
  }
`;
