import { ModuleControl } from "queenjs";
import { reactive } from "vue";
import { EditorModule } from "../../module";
const MusicOptions = [
  {
    label: "安静舒缓",
    value: "soothing&quiet",
    src: require("@/assets/audio/soothing&quiet.mp3"),
  },
  {
    label: "和煦的风",
    value: "balmy_wind",
    src: require("@/assets/audio/balmy_wind.mp3"),
  },
  {
    label: "纽约落日",
    value: "sunset_in_newyork",
    src: require("@/assets/audio/sunset_in_newyork.mp3"),
  },
  {
    label: "温情回忆",
    value: "warm_memories",
    src: require("@/assets/audio/warm_memories.mp3"),
  },
  {
    label: "春华秋实",
    value: "spring&autumn",
    src: require("@/assets/audio/spring&autumn.mp3"),
  },
  {
    label: "明媚阳光",
    value: "bright_sunshine",
    src: require("@/assets/audio/bright_sunshine.mp3"),
  },
  {
    label: "动感活力",
    value: "dynamic&energetic",
    src: require("@/assets/audio/dynamic&energetic.mp3"),
  },
  {
    label: "冲上云霄",
    value: "soar_into_the_sky",
    src: require("@/assets/audio/soar_into_the_sky.mp3"),
  },
  {
    label: "命运希望",
    value: "destiny&hope",
    src: require("@/assets/audio/destiny&hope.mp3"),
  },
  {
    label: "励志活力",
    value: "inspirational_vitality",
    src: require("@/assets/audio/inspirational_vitality.mp3"),
  },
  {
    label: "励志希望",
    value: "inspirational_hope",
    src: require("@/assets/audio/inspirational_hope.mp3"),
  },
  {
    label: "活力鼓舞",
    value: "inspiration_vigour",
    src: require("@/assets/audio/inspiration_vigour.mp3"),
  },
];

export class MediaCtrl extends ModuleControl<EditorModule> {
  state = reactive({
    medias: new Map<string, any>(),
    musicOptions: [{ label: "无", value: "", src: "" }, ...MusicOptions],
  });
  init() {
    this.state.medias.clear();
  }
  setMediasInstance(key: string, instance: any) {
    this.state.medias.set(key, instance);
  }
  pauseOtherMedia(currKey: string) {
    for (let [key, value] of this.state.medias) {
      if (key != currKey && value) {
        value.pause();
      }
    }
  }
  removeMedia(currKey: string) {
    this.state.medias.delete(currKey);
  }
  setMusicOptions(options: any) {
    this.state.musicOptions = options;
  }
}
