import { useCtx } from "@/comm/ctx";
import { EditorModule } from "..";
import { DesignComp } from "../../objects/DesignTemp/DesignComp";
import { EditorMode } from "../../typings";
import { queenApi } from "queenjs";

export const initActions = EditorModule.action({
  // 模块初始化
  init() {
    // const { historyCtrl } = this.controls;
    // historyCtrl.bindActions(Object.keys(editActions));
    this.controls.compUICtrl.init();
    this.controls.mediaCtrl.init();

    // createProxyEffect(this.store, (type, paths, value, oldValue) => {
    //   if (
    //     paths[0] === "designData" ||
    //     paths[0] === "currCompId" ||
    //     paths[0] === "selected" ||
    //     paths[0] === "currStreamCardId" ||
    //     paths[0] === "selectId"
    //   ) {
    //     historyCtrl.record(this.store, type, paths, value, oldValue);
    //   }
    // });
  },

  // 初始化数据
  async initDesign(id: string, isSys = false) {
    const ret = await this.https.getDesignDetail(id, { isSys });
    if (!ret.result.compMap) {
      const cate: any = this.store.tplCategory || [];
      const item = cate.find((d: any) => ret.result.categories?.includes(d.id));
      if (item && item.value == "PC") {
        ret.result.platform = "pc";
      } else {
        ret.result.platform = "mobile";
      }
    }
    const page = this.controls.pageCtrl;
    page.setDesignData(ret.result);
  },
  async initQueen5Design() {
    // const ret = await this.https.getDesignDetail(id, { isSys });
    const ctx = useCtx();
    let ret = await ctx.prjCtrl.loadQueen5();
    if (!ret) {
      if (location.href.indexOf("editor.html") == -1) {
        const params = new URLSearchParams(location.search);
        const projectPath = params.get("id") as string;
        const url = `${location.origin}/editor.html?id=${projectPath}#/`;
        location.href = url;
        return false;
      }

      ret = await this.actions.createLocalPromotion();
    }
    if (!ret.compMap) {
      const cate: any = this.store.tplCategory || [];
      const item = cate.find((d: any) => ret.categories?.includes(d.id));
      if (item && item.value == "PC") {
        ret.platform = "pc";
      } else {
        ret.platform = "mobile";
      }
    }
    const page = this.controls.pageCtrl;

    page.setDesignData(ret);
  },
  async initLocalFilesCache() {
    const ctx = useCtx();
    const ret = await ctx.prjCtrl.loadFilesCache();
    if (ret) {
      this.store.filesCacheUrl = ret;
    }
  },

  async initWkDesign(id: string) {
    this.store.setWk(true);
    const ret = await this.https.getWkDesignDetail(id);
    this.store.setDesignData(ret.result);
    return ret.result;
  },
  // 切换模式
  switchMode(v: EditorMode) {
    this.store.setMode(v);
  },
  setWkFlag(v: boolean) {
    this.store.setWk(v);
  },
  onViewReady(pageEl, selEl, viewPort) {
    // this.store.currStreamCardId = this.controls.pageCtrl.streamCardIds[0];
    this.controls.selectCtrl.initEvents(pageEl, selEl, viewPort);
  },

  onCompLayoutUpdated(comp: DesignComp) {
    //组件自身延迟加载了，影响了布局
    if (this.helper.isCurrComp(comp.id)) {
      const obj = this.controls.selectCtrl.gizmo.selected[0];
      obj.setSize(
        this.helper.designSizeToPx(comp.getW()),
        this.helper.designSizeToPx(comp.getH())
      );
    }
  },
});
