import { DesignComp } from "./DesignComp";
import { createObj } from "./factory";
// import { dataTransform } from "./versions/1.0.0";
import { dataTransform as V101Upgrade } from "./versions/1.0.1";
import { dataTransform as V102Upgrade } from "./versions/1.0.2";

export type CardState = {
  id: string;
  size: [number, number];
  children: {
    id: string;
    matrix: string;
    size: [number, number, { unit?: "px" | "%" }?];
  }[];
};

export class DesignTemp {
  version?: string;
  _id!: string;
  title = "";
  desc = "";
  pageStyle?: any;
  content: string[] = ["root"]; //rootPcShort rootPcNormal rootPcLong rootMobShort rootMobLong
  thumbnail?: string;
  categories: string[] = [];
  compMap: { [compId: string]: DesignComp } = {};
  compScreenMap: { [Screen: string]: CardState[] } = {};

  constructor(data?: Partial<DesignTemp>) {
    if (!data) return;

    const res = V101Upgrade(data);
    Object.assign(this, V102Upgrade(res));
    // 初始化DesignComp
    Object.entries(this.compMap).forEach(([key, value]) => {
      this.compMap[key] = createObj(value);
    });
  }
}
