import { TipIcons } from "../../components/TipIcons";
import { createToolbars } from "./default";


export const LayoutToolbars = createToolbars({
    xLeft: {
        component: TipIcons.AlignXLeft,
        getVisible(comp) { return  this.selected.length > 0 },
        onClick(comp, isGroup= false) {
            this.actions.setAlignX(0, isGroup);
        },
    },
    xCenter: {
        component: TipIcons.AlignXCenter,
        getVisible(comp) { return  this.selected.length > 0  },
        onClick(comp, isGroup= false) {
            this.actions.setAlignX(1, isGroup);
        },
    },
    xRight: {
        component: TipIcons.AlignXRight,

        getVisible(comp) { return  this.selected.length > 0   },
        onClick(comp, isGroup= false) {
            this.actions.setAlignX(2, isGroup);
        },
    },
    xBetween: {
        component: TipIcons.AlignXBetween,

        getVisible(comp) { return this.selected.length > 2 },
        onClick(comp) {
            this.actions.setAlignX(3);
        },
    },

    yBetween: {
        component: TipIcons.AlignYBetween,
        getVisible(comp) { return this.selected.length > 2 },
        onClick(comp, isGroup= false) {
            this.actions.setAlignY(3, isGroup);
        },
    },

    YTop: {
        component: TipIcons.AlignYTop,

        getVisible(comp) { return this.selected.length > 0  },
        onClick(comp, isGroup= false) {
            this.actions.setAlignY(0, isGroup);
        },
    },
    YCenter: {
        component: TipIcons.AlignYCenter,

        getVisible(comp) { return  this.selected.length > 0 },
        onClick(comp, isGroup= false) {
            this.actions.setAlignY(1, isGroup);
        },
    },
    YBottom: {
        component: TipIcons.AlignYBottom,
        getVisible(comp) { return this.selected.length > 0 },
        onClick(comp, isGroup= false) {
            this.actions.setAlignY(2, isGroup);
        },
    },

    Copy: {
        component: TipIcons.Copy,
        getVisible(comp) { return !!this.gizmo.state.lastId },
        onClick(comp) {
            this.actions.copyLastSelected();
        },
    },
    SameWidth: {
        component: TipIcons.SameWidth,
        getVisible(comp) { return this.selected.length > 0 },
        onClick(comp) {
            this.actions.setSameSize(true);
        },
    },
    SameHeight: {
        component: TipIcons.SameHeight,
        getVisible(comp) { return this.selected.length > 1 && !!this.gizmo.state.lastId },
        onClick(comp) {
            this.actions.setSameSize(false);
        },
    },
});