import { css } from "@linaria/core";
import { Button, Form, Input, Divider } from "ant-design-vue";
import { useModal } from "queenjs";
import { IconPc, IconPhone } from "@/assets/icons";
import { defineComponent, nextTick, onMounted, reactive, ref } from "vue";
import { any, string } from "vue-types";
import { useResource } from "..";
export default defineComponent({
  props: {
    sourceType: string().isRequired,
  },
  setup(props) {
    const { controls } = useResource();

    const formState: { [name: string]: any } = reactive({
      title: "",
      categories: "",
    });

    const state = reactive({
      categoryList: [] as any,
    });

    const getCate = () => {
      const categories = controls.categoryCtrl.state.categories;
      const currCate: any = categories.find((e: any) => {
        return e.value == props.sourceType;
      });
      getDefultCate(currCate?.children);
    };
    const getDefultCate = (options: any) => {
      if (!options) return;
      options.map((e: any) => {
        if (e.name == "平台") {
          state.categoryList = e.children;
          formState.categories = e.children[0].id;
          return;
        }
      });
    };
    onMounted(() => {
      getCate();
    });

    const rules = ref({
      title: [
        {
          required: true,
          message: "标题不能为空！",
        },
      ],
    });

    const { validate, validateInfos } = Form.useForm(formState, rules);

    const modal = useModal();

    const submit = () => {
      validate().then(async (values) => {
        formState.categories = [formState.categories];
        modal.submit(formState);
      });
    };
    const platformChange = (id: string) => {
      formState.categories = id;
    };

    return () => {
      return (
        <div class={configFormStyle}>
          <div class="modal_form">
            <Form name="basic">
              <Form.Item name="title" {...validateInfos.title}>
                <Input
                  v-model={[formState.title, "value"]}
                  placeholder={"请输入作品标题"}
                />
              </Form.Item>
              <Divider style={{ borderColor: "#1f1f1f" }} />
              <Form.Item name="categories">
                <SelectPlatforms
                  value={formState.categories}
                  options={state.categoryList}
                  onChange={platformChange}
                />
              </Form.Item>
            </Form>
          </div>
          <div class="modal_footer">
            <Button type="primary" block onClick={submit}>
              创建设计
            </Button>
          </div>
        </div>
      );
    };
  },
});
const SelectPlatforms = defineComponent({
  props: {
    value: any(),
    options: any(),
  },
  emits: ["change"],
  setup(props, { emit }) {
    return () => (
      <div class={SelectStyle}>
        <div>选择屏幕类型</div>
        <div class={"select_wapper mt-20px"}>
          {props.options.map((e: any) => {
            return (
              <div
                class={["select_item", props.value == e.id ? "actvie" : ""]}
                onClick={() => {
                  emit("change", e.id);
                }}
              >
                {e.name == "手机" ? (
                  <IconPhone class={"text-40px"} />
                ) : (
                  <IconPc class={"text-40px"} />
                )}
                <div class={"mt-15px"}>
                  {e.name == "手机" ? "H5移动端" : "PC端"}
                </div>
              </div>
            );
          })}
        </div>
      </div>
    );
  },
});
const SelectStyle = css`
  .select_wapper {
    display: flex;
    align-items: center;
    .select_item {
      padding: 22px 0;
      flex: 1;
      border: 1px solid transparent;
      border-radius: 6px;
      text-align: center;
      background-color: #303030;
      cursor: pointer;
      &:last-child {
        margin-left: 20px;
      }
      &.actvie {
        background-color: #262626;
        border-color: @inf-primary-color;
      }
    }
  }
`;
const configFormStyle = css`
  .thumb_wapper {
    height: 180px;
  }
  .modal_footer {
  }
`;
