import { queenApi } from "queenjs";
import { Provider } from "queenjs/adapter/vue";
import { createApp, defineComponent, reactive } from "vue";
import { Router } from "vue-router";
import "@/styles";
import zh_cn from "ant-design-vue/es/locale/zh_CN";
import { InitControllers } from "@/comm/ctx";
let setModuleHooks: any[] = [];

const App = defineComponent(() => {
  const state = reactive({
    loading: true,
  });
  InitControllers().then(() => {
    state.loading = false;
  });
  setModuleHooks.forEach((hook) => hook());
  setModuleHooks = [];
  return () => (
    <>
      {!state.loading && (
        <Provider locale={zh_cn}>
          <router-view></router-view>
        </Provider>
      )}
    </>
  );
});

export function startApp(
  router: Router,
  hooks: any[] = [],
  callback?: (app: ReturnType<typeof createApp>) => void
) {
  setModuleHooks = hooks;
  queenApi.router = router;
  const app = createApp(App);
  callback?.(app);
  app.use(router).mount("#app");
}
